﻿Imports System.Xml.Serialization
Imports System.IO

<Serializable()> Public Class GenericConfig
    Private filePath As String = ""
    Public items As New List(Of serializableItem)

    Public Function getItem(ByVal key As String) As serializableItem
        Return items.Find(New Predicate(Of serializableItem)(Function(obj As serializableItem)
                                                                 Return obj.key = key
                                                             End Function))
    End Function

    Public Function getItemValue(ByVal key As String) As String
        Return getItem(key).value
    End Function

    Public Sub setItem(ByVal key As String, ByVal value As String, Optional ByVal hasSubItems As Boolean = False)
        Dim p As New Predicate(Of serializableItem)(Function(obj As serializableItem)
                                                        Return obj.key = key
                                                    End Function)
        If items.Exists(p) Then
            items.Remove(items.Find(p))
        End If
        items.Add(New serializableItem(key, value, hasSubItems))
    End Sub

    Public Shared Function load(ByVal f As String) As GenericConfig
        Dim xs As New XmlSerializer(GetType(GenericConfig))
        Dim sr As New StreamReader(f)
        Dim data As GenericConfig = CType(xs.Deserialize(sr), GenericConfig)
        sr.Close()
        data.filePath = f
        Return data
    End Function

    Public Sub Save()
        Dim xs As New XmlSerializer(GetType(GenericConfig))
        Dim sw As New StreamWriter(filePath)
        xs.Serialize(sw, Me)
        sw.Close()
    End Sub
End Class

<Serializable()> Public Class serializableItem
    <XmlAttribute()> Public key As String
    <XmlAttribute()> Public value As String
    Public subItems As List(Of serializableItem)

    Sub New()
    End Sub

    Sub New(ByVal k As String, ByVal v As String, Optional ByVal hasSubItems As Boolean = False)
        key = k
        value = v
        If hasSubItems Then subItems = New List(Of serializableItem)
    End Sub

    Public Function subItemsValues() As List(Of String)
        If IsNothing(subItems) Then subItems = New List(Of serializableItem)
        Dim result As New List(Of String)
        For Each i As serializableItem In subItems
            result.Add(i.value)
        Next
        Return result
    End Function

    Public Sub removeSubItem(ByVal val As String)
        subItems.RemoveAll(New Predicate(Of serializableItem)(Function(obj As serializableItem)
                                                                  Return obj.value = val
                                                              End Function))
    End Sub
End Class
