Imports System.XML.Serialization
Imports System.IO
Imports System.Xml.Xsl
Imports AddOnsLib
Imports LangLib

<Serializable()> Public Class Project

    Public name As String
    Public applications As New List(Of ProjectApplication)
    Public detailsTabOpened As Boolean
    <NonSerialized()> Public File As String

    Sub New()
    End Sub

    Sub New(ByVal n As String)
        name = n
    End Sub

    Public Shared Function Open(ByVal f As String) As Project
        Dim xs As New XmlSerializer(GetType(Project))
        Dim sr As New StreamReader(f)
        Dim p As Project = CType(xs.Deserialize(sr), Project)
        sr.Close()
        p.File = f
        For i As Integer = 0 To p.applications.Count - 1
            Dim app As ProjectApplication = p.applications(i)
            Dim d As String = My.Computer.FileSystem.GetParentPath(f) & "\src\" & app.Name
            If My.Computer.FileSystem.DirectoryExists(d) Then
                app.dir = d
            Else
                MsgBox(getMsg("appDirNotFound", app.Name), MsgBoxStyle.Critical)
                app.dir = ""
            End If
            For Each fl As fileDetails In app.AppFiles
                If Not My.Computer.FileSystem.FileExists(app.filePath(fl)) Then
                    MsgBox(getMsg("appFileNotFound", fl.fInfo.Name), MsgBoxStyle.Critical)
                End If
            Next
            If Not MainForm.addons.exists(itemType.AppType, app.AppType) Then
                MsgBox(getMsg("appTypeNotFound", app.AppType), MsgBoxStyle.Critical)
            Else
                Dim c As ApplicationType = MainForm.addons.getAppType(app.AppType)
                Dim t As List(Of ApplicationOptionType) = c.OptionTypes
                If Not Object.Equals(t, Nothing) Then
                    For Each opT As ApplicationOptionType In t
                        If opT.necessary Then
                            Dim ok As Boolean = False
                            For Each Op As ApplicationOption In app.AppOptions
                                If Op.name = opT.name Then
                                    ok = True
                                    Exit For
                                End If
                            Next
                            If Not ok Then
                                MsgBox(getMsg("appOptionNotFound", opT.name, app.Name), MsgBoxStyle.Critical)
                            End If
                        End If
                    Next
                    For Each op As ApplicationOption In app.AppOptions
                        If Not c.optionExists(op.name) Then
                            MsgBox(getMsg("appOptionNotExists", op.name, app.AppType), MsgBoxStyle.Critical)
                        End If
                    Next
                End If
            End If
        Next
        Return p
    End Function

    Private Sub setOpenedFiles(ByVal AppFiles As TabControl)
        If CBool(MainForm.mainSettings.getItemValue("reopenFiles")) Then
            For Each currTab As TabPage In AppFiles.TabPages
                Dim f As String = CType(currTab.Tag, tabInfo).f
                If f = File Then
                    detailsTabOpened = True
                ElseIf f <> "" Then
                    For Each app As ProjectApplication In applications
                        app.setFileOpen(f.Remove(0, app.dir.Length))
                    Next
                End If
            Next
        End If
    End Sub

    Private Sub Save(ByVal f As String)
        Dim xs As New XmlSerializer(GetType(Project))
        Dim sw As New StreamWriter(f)
        xs.Serialize(sw, Me)
        sw.Close()
    End Sub

    Public Sub Save(ByVal AppFiles As TabControl)
        setOpenedFiles(AppFiles)
        Save(File)
    End Sub

    Public Sub Save()
        Save(File)
    End Sub

    Public Function dir() As String
        Return My.Computer.FileSystem.GetParentPath(File)
    End Function
End Class
