﻿Imports LangLib
Imports System.Windows.Forms

Public Class SettingsDialog

    Dim languages As New List(Of String)

    Private Sub SettingsDialog_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        applyLang(Me)
        refreshLangs()
    End Sub

    Sub refreshLangs()
        languages.Clear()
        lng.Items.Clear()
        For Each lPath As String In My.Computer.FileSystem.GetFiles(Application.StartupPath & "\lang\")
            Dim fInfo As New IO.FileInfo(lPath)
            Dim lName As String = fInfo.Name.Remove(fInfo.Name.Length - 4, 4)
            If lName <> "_def" Then
                Try
                    Dim l As Lang = Lang.load(lPath)
                    languages.Add(lName)
                    lng.Items.Add(l.fullName)
                    If MainForm.mainSettings.getItemValue("lang") = lName Then lng.SelectedItem = l.fullName
                Catch ex As Exception
                End Try
            End If
        Next
    End Sub

    Private Sub btnInstallLang_Click(sender As Object, e As EventArgs) Handles btnInstallLang.Click
        If AdministratorControl.check() Then
            Dim lr As New LangRepoExplorer
            lr.ShowDialog()
            refreshLangs()
        End If
    End Sub

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        MainForm.mainSettings.setItem("lang", languages(lng.SelectedIndex))
        MainForm.mainSettings.Save()
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub btnCancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub
End Class
