﻿Imports LangLib

Public Class addonDependancySolver
    Public Shared Function solveDependancies(ByVal mf As addonManifest) As addonDependancySolverResult
        Dim result As New addonDependancySolverResult
        'result.universalideCompatibility.Add(New Compatibility())
        For Each d As addonDependancy In mf.dep
            Dim dManifest As addonManifest = RepositoryApi.getAddonManifest(d.addonName)
            result.dep.Add(d)
            If MainForm.addons.installedAddons.Contains(dManifest) Then
                Dim installedVersion As Version = MainForm.addons.installedAddons.Find(Function(obj As addonManifest) As Boolean
                                                                                           Return obj.shortName = dManifest.shortName
                                                                                       End Function).getVersion()
                Select Case d.comp.Find(Function(obj As Compatibility) As Boolean
                                            Return obj.getVersion() = installedVersion
                                        End Function).lv
                    Case compatibilityLevel.yes
                        result.depStatus.Add(dependancyStatus.ok)
                    Case compatibilityLevel.unknown
                        result.depStatus.Add(dependancyStatus.unknownSupport)
                    Case compatibilityLevel.no
                        result.depStatus.Add(dependancyStatus.versionUnsupported)
                End Select
            Else
                result.depStatus.Add(dependancyStatus.missing)
            End If
            result.s &= dManifest.fullName & " (" & getMsg("dependancyStatus." & result.depStatus(result.depStatus.Count - 1).ToString) & ") (" & getMsg("compatibilityLevel." & mf.checkCompatibility().ToString()) & ")" & Environment.NewLine
            For Each d1 As addonDependancy In dManifest.dep
                Dim d1Manifest As addonManifest = RepositoryApi.getAddonManifest(d.addonName)
                Dim subdep As addonDependancySolverResult = solveDependancies(d1Manifest)
                result.s &= "-" & subdep.s
                result.dep.AddRange(subdep.dep)
            Next
        Next
        Return result
    End Function
End Class
