﻿Imports System.Xml.Serialization
Imports System.IO

<Serializable()> Public Class addonManifest
    Implements IEquatable(Of addonManifest)

    Public shortName As String
    Public fullName As String
    Public developerName As String
    Public developerLink As String
    Public developerID As String
    Public assemblyFileName As String
    Public description As String
    Public version As String
    Public universalideCompatibility As New List(Of Compatibility)
    Public dep As New List(Of addonDependancy)

    Public Function getVersion() As Version
        Return System.Version.Parse(version)
    End Function

    Public Shared Function load(ByVal f As String) As addonManifest
        Dim xs As New XmlSerializer(GetType(addonManifest))
        Dim sr As New StreamReader(f)
        Dim data As addonManifest = CType(xs.Deserialize(sr), addonManifest)
        sr.Close()
        Return data
    End Function

    Public Shared Function loadString(ByVal s As String) As addonManifest
        Dim xs As New XmlSerializer(GetType(addonManifest))
        Dim sr As New StringReader(s)
        Dim data As addonManifest = CType(xs.Deserialize(sr), addonManifest)
        sr.Close()
        Return data
    End Function

    Public Sub save(ByVal f As String)
        Dim xs As New XmlSerializer(GetType(addonManifest))
        Dim sw As New StreamWriter(f)
        xs.Serialize(sw, Me)
        sw.Close()
    End Sub

    Public Function checkCompatibility() As compatibilityLevel
        Dim pr As New Predicate(Of Compatibility)(Function(obj As Compatibility) As Boolean
                                                      Return obj.getVersion() = My.Application.Info.Version
                                                  End Function)
        Dim result As Compatibility = universalideCompatibility.Find(pr)
        If IsNothing(result) Then
            Return compatibilityLevel.unknown
        Else
            Return result.lv
        End If
    End Function

    Public Function Equals1(other As addonManifest) As Boolean Implements IEquatable(Of addonManifest).Equals
        Return shortName = other.shortName
    End Function
End Class